; The main program
openAppli(); ouverture des prfrences

If InitEngine3D()
  
  ;{ init (keyboard, mouse, archive..)
  If InitSprite() = 0 Or InitKeyboard() = 0 Or InitMouse()=0 ;Or UsePNGImageDecoder()=0
    MessageRequester("Error", "The DirectX Engine can't be initialized",0)
    End    
  EndIf 
  ;}
  ;{ macro
  XIncludeFile "include\procedures\ase3D_macros.pb"
  ;}

  If OpenMainWindow()
    
    ;{ addressources / script
    Add3DArchive("data", #PB_3DArchive_FileSystem)
    Add3DArchive("data/textures", #PB_3DArchive_FileSystem)
    Add3DArchive("data/models", #PB_3DArchive_FileSystem)
    Add3DArchive("data/material", #PB_3DArchive_FileSystem)
    Add3DArchive("data/shaders", #PB_3DArchive_FileSystem)
    Add3DArchive("data/ui", #PB_3DArchive_FileSystem)
    
    Add3DArchive("data/other/puf", #PB_3DArchive_FileSystem)
    Add3DArchive("data/torchlight", #PB_3DArchive_FileSystem)
    Add3DArchive("data/torchlight/skyboxe", #PB_3DArchive_FileSystem)
    Add3DArchive("data/torchlight/town1", #PB_3DArchive_FileSystem)
    
    Parse3DScripts()
    ;}
    ;{ init 3D  
    
    ;{ le world
    AmbientColor(0)
    WorldShadows(#PB_Shadow_Additive) ;}
    ;{ les "objets" pour l'interface de l'diteur
    CreateBoundingBoxRect()
    ; camera
    CreateCamera(#CameraGame, 0, 0, 100, 100)  ; Front camera
    CameraLocate(#CameraGame, 0, 0, 400)
    CameraBackColor(#CameraGame, RGB(125,125,125))
    SetCameraProp() : InitCamera() :     
    AddAsset(camera\name$,camera\pos\X,camera\pos\y,camera\pos\Z,12)
    UpdateTreeGadget()
    
    ; ui cible
;     CreateMaterial(#UICible, LoadTexture(#UiTxCible, "cible_ed.png"))
;     MaterialBlendingMode(#UICible,#PB_Material_AlphaBlend)
;     CreateBillboardGroup(0, MaterialID(#UICible), 10, 10)
;     AddBillboard(0,0,0,0,0)

    ; la grille
    CreateGrid() : AddGrid() : AddMarker3D()   
    ;}
    
    ; les light par dfaut : on en cr 3 (voir dans arkeos3D_mapEd_procedures.pb
    LightDefaut()    
    
    ; on ajoute les banque et un objet par defaut  
    OpenBankGroup() : GbBankGroup = "Personnage" : OpenBankTheme() : OpenBankAsset() : InitObj() : OpenBankMaterial() : UpdateListSelect()
    InitLevel() : UpdateInfos()
    
    ;}
    ;{ add the UI and the mouse
    KeyboardMode(#PB_Keyboard_International) 
    ShowCursor_(1)     
    ;}
    ;{ main loop
    
    Repeat
      If ExamineKeyboard() And GBFocusGadget =0
        ;{ mouse
        If ExamineMouse()
            SetActiveGadget(#Gadget_ShowCible)
            If Not KeyboardPushed(#PB_Key_LeftShift) ;And KeyboardPushed(#PB_Key_LeftAlt))
              If KeyboardPushed(#PB_Key_LeftAlt)
                If camera\lookat = 0
                  If MouseButton(#PB_MouseButton_Left)                              
                    MouseX = - MouseDeltaX() * #CameraSpeed * camera\factorMove
                    MouseY = - MouseDeltaY() * #CameraSpeed * camera\factorMove
                  Else                 
                    ResetAll()
                  EndIf                  
                Else
                  If MouseButton(#PB_MouseButton_Left)                              
                    KeyY =  MouseDeltaY() * #CameraSpeed * camera\factorMove
                    KeyX = - MouseDeltaX() * #CameraSpeed * camera\factorMove   
                  Else                 
                    ResetAll()
                  EndIf                  
                EndIf
                KeyZ = - MouseWheel()*#CameraSpeed *option\ViewZoom
              Else
                If MouseButton(#PB_MouseButton_Left) 
                  GbtransformOk = 0
                  If MouseClick = 0 And GbtransformObject < 0
                    MouseClick =1                  
                    MousePick(#CameraGame, MouseX(), MouseY())
                    CreateObjet(0,PickX(),PickY(),PickZ())                  
                  EndIf
                Else
                  If camera\view = 0
                    BaseCamera()
                  EndIf
                  
                  If GbtransformOk = 1 And Not KeyboardPushed(#PB_Key_All)
                    If GbtransformObject =2 ; move
                      If IsEntity(GbEntity\entityId)                                              
                        MousePick(#CameraGame, MouseX(), MouseY()-10)
                        SetInfoObjet(0,1)
                      EndIf
                    ElseIf GbtransformObject =1 ;rotate                     
                        SetInfoObjet(0,3)                      
                    ElseIf GbtransformObject =3 ;scale
                      If IsEntity(GbEntity\entityId)
                        Key_Y = -MouseDeltaY() 
                        Key_X = -MouseDeltaX() * 0.01
                        If Key_Y* 0.005>-1
                          SetInfoObjet(0,2,Key_y) 
                        EndIf                      
                      EndIf                    
                    EndIf
                  EndIf
                EndIf                
              EndIf
              KeyZ = -MouseWheel()*#CameraSpeed * option\ViewZoom 
            Else
              If camera\lookat = 0
                If MouseButton(#PB_MouseButton_Left) 
                  KeyY =  MouseDeltaY() * #CameraSpeed * camera\factorMove
                  KeyX = -MouseDeltaX() * #CameraSpeed * camera\factorMove                            
                Else                   
                  ResetAll()
                EndIf
              Else
                If MouseButton(#PB_MouseButton_Left) 
                  camera\lookatY + MouseDeltaY() *  camera\factorMove
                  camera\lookatX - MouseDeltaX() *  camera\factorMove                   
                EndIf                
              EndIf            
              KeyZ = -MouseWheel()*#CameraSpeed * option\ViewZoom 
            EndIf
            ;{ selection d'un objet
            If MouseButton(#PB_MouseButton_Right) 
              If KeyboardPushed(#PB_Key_LeftShift) 
                ent = MousePick(0, MouseX(), MouseY()) 
                selectObject(ent)   
              Else 
                If MouseClick = 0
                  SelectAllObject(0)
                  GbEntity\entityId = MousePick(0, MouseX(), MouseY())
                  selectObject(GbEntity\entityId) 
                  ModifyObjet()                                       
                  MouseClick =1
                  GbtransformObject = 0
                  BoundingBox()                  
                EndIf              
              EndIf
            Else
              MouseClick =0
            EndIf            
            ; on arrte de modifier l'objet            
            If MouseButton(#PB_MouseButton_Left)    
              If MouseButton(#PB_MouseButton_Left)=0
                GbtransformObject = -1
                MouseClick =0
              EndIf 
            EndIf
            ;}
          EndIf      ;}
        ;{ keyboard
          If KeyboardPushed(#PB_Key_LeftControl) 
            If KeyboardPushed(#PB_Key_Y) 
              camera\Axe = 3
              SetGadgetState(#Gadget_Axe,camera\Axe)
            ElseIf KeyboardPushed(#PB_Key_Z)
              camera\Axe = 4  
              SetGadgetState(#Gadget_Axe,camera\Axe)
            ElseIf KeyboardPushed(#PB_Key_X)
              camera\Axe = 5  
              SetGadgetState(#Gadget_Axe,camera\Axe)
            EndIf    
          Else
            ;{ R G S = dplacement des objet avec les touches du clavier : RGS (comme blender)
            If KeyboardPushed(#PB_Key_R)
              GbtransformObject = 1
              GbtransformOk = 1
            ElseIf KeyboardPushed(#PB_Key_G)
              GbtransformObject = 2
              GbtransformOk = 1
            ElseIf KeyboardPushed(#PB_Key_S)
              GbtransformObject = 3
              GbtransformOk = 1
            EndIf ;}
            ;{ axe of camera
            If KeyboardPushed(#PB_Key_X)
              camera\Axe = 0
              SetGadgetState(#Gadget_Axe,camera\Axe)
            ElseIf KeyboardPushed(#PB_Key_Y)
              camera\Axe = 1 
              SetGadgetState(#Gadget_Axe,camera\Axe)
            ElseIf KeyboardPushed(#PB_Key_Z)
              camera\Axe = 2 
              SetGadgetState(#Gadget_Axe,camera\Axe)
            EndIf              
            ;}
            
          If IsLight(GbEntity\entityId) Or IsEntity(GbEntity\entityId)
            
            Select GbtransformObject  
                
              Case 1 ; rotation
                If KeyboardPushed(#PB_Key_Left)              
                  RotateEntity(GbEntity\entityId, 0, -1, 0, #PB_Relative)                  
                  SetInfoObjet() : GbtransformOk = 0                  
                ElseIf KeyboardPushed(#PB_Key_Right)
                  RotateEntity(GbEntity\entityId, 0, 1, 0, #PB_Relative)
                  SetInfoObjet() : GbtransformOk = 0    
                EndIf                
                
              Case 2 ; move                
                If KeyboardPushed(#PB_Key_Left)                   
                  MoveEntity(GbEntity\entityId, -1, 0, 0)
                  SetInfoObjet() : GbtransformOk = 0    
                ElseIf KeyboardPushed(#PB_Key_Right)
                  MoveEntity(GbEntity\entityId, 1, 0, 0)
                  SetInfoObjet() : GbtransformOk = 0    
                EndIf
                
                If Not KeyboardPushed(#PB_Key_RightControl)
                  If KeyboardPushed(#PB_Key_Up)              
                    MoveEntity(GbEntity\entityId, 0, 0, -1)
                    SetInfoObjet() : GbtransformOk = 0    
                  ElseIf KeyboardPushed(#PB_Key_Down)
                    MoveEntity(GbEntity\entityId, 0, 0, 1) 
                    SetInfoObjet() : GbtransformOk = 0    
                  EndIf
                Else
                  If KeyboardPushed(#PB_Key_Up)              
                    MoveEntity(GbEntity\entityId, 0, 1, 0)
                    SetInfoObjet() : GbtransformOk = 0    
                  ElseIf KeyboardPushed(#PB_Key_Down)
                    MoveEntity(GbEntity\entityId, 0, -1, 0) 
                    SetInfoObjet() : GbtransformOk = 0    
                  EndIf
                EndIf
      
              Case 3 ; scale                
                If KeyboardPushed(#PB_Key_Up)              
                  ScaleEntity(GbEntity\entityId, 1.01, 1.01, 1.01)
                  GbEntity\size + 0.1
                  SetInfoObjet() : GbtransformOk = 0    
                ElseIf KeyboardPushed(#PB_Key_Down)
                  ScaleEntity(GbEntity\entityId, 0.99, 0.99, 0.99)
                  GbEntity\size - 0.1
                  SetInfoObjet() : GbtransformOk = 0    
                EndIf             
            EndSelect            
          EndIf          
        EndIf
        
        If KeyboardReleased(#PB_Any)
          ResetAll()
        EndIf
        ;}
      EndIf
      ;{ update the scene
      If camera\lookat = 1 And IsEntity(GbEntity\entityId)
        RotateCamera(#CameraGame, MouseY, MouseX, 0,#PB_Relative)
        MoveCamera  (#CameraGame, KeyX, KeyY, KeyZ)
        CameraLookAt(#CameraGame,EntityX(GbEntity\entityId)+camera\lookatX,EntityY(GbEntity\entityId)+camera\lookatY,EntityZ(GbEntity\entityId))
      Else
        RotateCamera(#CameraGame, MouseY, MouseX, 0,#PB_Relative)
        MoveCamera  (#CameraGame, KeyX, KeyY, KeyZ)
      EndIf
      
      If GbEntity\EntityId>0
        EntityLocate(#BoundingBox,EntityX(GbEntity\EntityId),EntityY(GbEntity\EntityId),EntityZ(GbEntity\EntityId))
      EndIf
;       If fog_dist>5000
;         fog_dist -1
;         Fog(#White, 1,0,fog_dist)
;       EndIf
  
      RenderWorld()
      Screen3DStats() 
      FlipBuffers()
      ;}
      GestionMouse()
      Quit = Screen3DEvents(); les autres events
    Until KeyboardPushed(#PB_Key_Escape) Or Quit = 1
    closeAppli() 
  Else
    MessageRequester("Error", "Can't create the Window",0)
  EndIf
  ;}
  
Else
  MessageRequester("Error", "The 3D Engine can't be initialized",0)
EndIf

End
; IDE Options = PureBasic 5.00 Beta 6 (Windows - x86)
; CursorPosition = 291
; Folding = wK5
; EnableXP
; EnableOnError
; EnablePurifier